<?php


namespace app\app_kami\controller;


use think\facade\Db;
use think\facade\View;

class Index extends Base
{
    public function index()
    {
        $userInfo = $this->getUserInfo();
        $pid = input('pid');
        $id = input('id');
        $shop = Db::name('app_kami_shop')->where(['pid' => $pid, 'id' => $id])->find();
        if($shop){
            $shop['topimg'] = json_str_to_array($shop['topimg']);
        }
        if(!$shop || $shop['state']!=1) {
            header('HTTP/1.1 404 Not Found');
            header("status: 404 Not Found");
            exit();
        }
        $countdown = 0;
        if ($shop) {
            $countdown = $shop['end_time'] - time();
            Db::name('app_kami_shop')->where(['pid' => $pid, 'id' => $id])->update(['pv'=>Db::raw('pv+1')]);
        }

        [$wechatConfig, $jsApiList] = $this->getWechatJsConfig();

        $wechatShare = [
            'title' => $shop['title'],
            'desc' => $shop['fx_text'],
            'link' => $this->request->domain() . '/app_kami.html?pid='.$pid.'&id='.$id,
            'imgUrl' => $this->getFullMediaUrl($shop['fx_img'])
        ];
        View::assign([
            'shop' => $shop,
            'countdown' => $countdown < 0 ? 0 : $countdown,
            'wechatShareConfig' => $wechatConfig,
            'wechatShare' => $wechatShare,
            'jsApiList' => $jsApiList
        ]);
        return View::fetch();
    }
    public function place()
    {
        $pid = input('pid');
        $id = input('id');
        $kami = input('kami');
        $type = input('type');
        if(!$type) $this->error('请确定支付方式');
        $shopInfo = Db::name('app_kami_shop')->where(['pid' => $pid, 'id' => $id])->find();
        if (!$shopInfo) $this->error('不存在的商品');
        if ($shopInfo['end_time'] && $shopInfo['end_time'] - time() <= 0) $this->error('活动结束啦~');

        $userInfo = $this->getUserInfo();
        $kamiInfo = [];
        if($type==2){
            // 卡密
            $order = Db::name('app_kami_order')->where(['pid' => $pid, 'paytype' => 2, 'gid'=>$id, 'openid' => $userInfo['openid'],'status' => null])->whereNull('status')->find();
            if($order){
                $orderNo = uniqidDate();
                Db::name('app_kami_order')->where('id', $order['id'])->update(['orderid'=>$orderNo]);
                $this->success('下单成功', null, [
                    'order_no' => $orderNo,
                    'user_ip' => getip(),
                    'fee' => $shopInfo['new_price'] + $shopInfo['yf_price'],
                    'sc_price'=> $shopInfo['new_price']?? '0.00',
                    'old_price'=> $shopInfo['old_price']?? '0.00',
                    'new_price'=> $shopInfo['new_price']?? '0.00',
                    'yf_price'=> $shopInfo['yf_price']?? '0.00'
                ]);
            }
            // 到这说明是第一次下单，要判断卡密是否输入
            if(!$kami) $this->error('请输入卡密', null, ['show_kami'=>1]);
            $kamiInfo = Db::name('app_kami_kami')->where(['pid' => $pid, 'gid' => $id, 'code' => $kami])->find();
            if (!$kamiInfo) $this->error('卡密不存在');
            if ($kamiInfo['pay_time']) $this->error('卡密已使用');
        }else{
            $order = Db::name('app_kami_order')->where(['pid' => $pid, 'paytype' => 1, 'gid'=>$id, 'openid' => $userInfo['openid']])->whereNull('status')->find();
            if ($order){
                // 更新订单号以及订单金额
                $orderNo = uniqidDate();
                Db::name('app_kami_order')->where('id', $order['id'])->update([
                    'orderid' => $orderNo,
                    'user_ip' => getip(),
                    'fee' => $shopInfo['old_price']+$shopInfo['yf_price'],
                    'sc_price'=> $shopInfo['new_price']?? '0.00',
                    'old_price'=> $shopInfo['old_price']?? '0.00',
                    'new_price'=> $shopInfo['new_price']?? '0.00',
                    'yf_price'=> $shopInfo['yf_price']?? '0.00',
                ]);
                $this->success('下单成功', null, ['order_no' => $orderNo]);
            }
        }
        if($type==2 && !$kamiInfo) $this->error('请输入正确的卡密');

        Db::startTrans();
        try {
            $orderNo = uniqidDate();
            if ($kamiInfo) {
                Db::name('app_kami_kami')->where('id', $kamiInfo['id'])->update([
                    'uid' => $userInfo['id'],
                    'pay_time' => time()
                ]);
            }
            Db::name('app_kami_order')->insert([
                'uid' => $userInfo['id'],
                'pid' => $pid,
                'gid' => $id,
                'orderid' => $orderNo,
                'paytype' => $kamiInfo ? 2 : 1,
                'openid' => $userInfo['openid'],
                'avatar' => $userInfo['headimgurl'],
                'nickname' => $userInfo['nickname'],
                'user_ip' => getip(),
                'fee' => $kamiInfo ? ($shopInfo['new_price'] + $shopInfo['yf_price']) : ($shopInfo['old_price']+$shopInfo['yf_price']),
                'sc_price'=> $shopInfo['new_price']?? '0.00',
                'old_price'=> $shopInfo['old_price']?? '0.00',
                'new_price'=> $shopInfo['new_price']?? '0.00',
                'yf_price'=> $shopInfo['yf_price']?? '0.00',
                'km_id' => $kamiInfo['id'] ?? null,
                'kami' => $kamiInfo['code'] ?? null,
                'create_time' => time()
            ]);
            Db::commit();
        } catch (\Exception $e) {
            Db::rollback();
            throw $e;
        }

        $this->success('下单成功', null, ['order_no' => $orderNo]);
    }

    public function user()
    {
        $pid = input('pid');

        $userInfo = $this->getUserInfo();
        $orderList = Db::name('app_kami_order')->alias('o')
            ->leftJoin('vit_app_kami_shop s', 'o.gid=s.id')
            ->field('o.*, s.title shop_title, s.topimg shop_topimg, s.type shop_type,s.store_address,s.phone, s.location shop_location, s.store_address')->order('o.id desc')
            ->where(['o.pid' => $pid, 'o.openid' => $userInfo['openid']])->select();
        $orders = $orderList->isEmpty() ? [] : $orderList->toArray();
        foreach($orders as &$order){
            $order['shop_topimg'] = json_str_to_array($order['shop_topimg']);
        }

        [$wechatConfig, $jsApiList] = $this->getWechatJsConfig();

        View::assign([
            'userInfo' => $userInfo,
            'orders' => $orders,
            'wechatShareConfig' => $wechatConfig,
            'jsApiList' => $jsApiList
        ]);
        return View::fetch();
    }

    public function order()
    {
        $pid = input('pid');
        $id = input('id');
        $paytype = input('type');
        $userInfo = $this->getUserInfo();
        $order = Db::name('app_kami_order')->where(['pid' => $pid, 'paytype' => $paytype, 'gid'=>$id, 'openid' => $userInfo['openid']])->whereNull('status')->find();
        if (!$order) $this->error('未知的订单信息');
        $shopInfo = Db::name('app_kami_shop')->where(['pid' => $pid, 'id' => $order['gid']])->find();

        [$wechatConfig, $jsApiList] = $this->getWechatJsConfig();

        if ($this->request->isPost()) {
            if ($shopInfo['end_time'] && $shopInfo['end_time'] - time() <= 0) $this->error('活动结束啦~');
            $post = $this->request->post();
            if (!$post['name']) $this->error('请填写收货人姓名');
            if (!$post['phone']) $this->error('请填写联系电话');
            if($shopInfo['type']==1){
                if (!$post['area']) $this->error('请选择地区');
                if (!$post['address']) $this->error('请填写收货人地址');
            }

            $updateData = [
                'name' => $post['name'],
                'phone' => $post['phone'],
            ];
            if($shopInfo['type']==1){
                $updateData['address'] = $post['area'] . ' ' . $post['address'];
            }

            // 如果订单支付金额为0，则直接成功
            if($order['fee'] <= 0){
                $updateData['status'] = 1;
                $updateData['paytime'] = time();
                Db::name('app_kami_order')->where('id', '=', $order['id'])->update($updateData);
                $this->success('支付成功');
            }

            $weixinConfig = Db::name('app_kami_weixin')->where(['pid' => $pid])->find();
            $config = [
                'appsecret' => $weixinConfig['appsecret'],
                'appid' => $weixinConfig['appid'],
                'mch_id' => $weixinConfig['mchid'],
                'mch_key' => $weixinConfig['apikey']
            ];
            $params = [
                'body' => $setup['title'] ?? '商品支付',
                'out_trade_no' => $order['orderid'],
                'total_fee' => $order['fee'] * 100,
                'openid' => $order['openid'],
                'trade_type' => 'JSAPI',
                'notify_url' => $this->request->domain() . '/app_kami/pay/callback/pid/' . $pid,
            ];

            $wechat = new \WeChat\Pay($config);
            if (!$order['prepay_id'] || !$order['time_expire'] || (time() - $order['time_expire'] > 7200)) {
                $result = $wechat->createOrder($params);
                if (!$result['prepay_id']) $this->error('下单失败');
                $updateData['prepay_id'] = $result['prepay_id'];
                $updateData['time_expire'] = time() + 7200;
                $prepayId = $result['prepay_id'];
            } else {
                $prepayId = $order['prepay_id'];
            }

            Db::name('app_kami_order')->where('id', '=', $order['id'])->update($updateData);

            $options = $wechat->createParamsForJsApi($prepayId);
            $this->success('请支付', null, ['params' => $options]);
        }
        View::assign([
            'order' => $order,
            'wechatConfig' => $wechatConfig,
            'jsApiList' => $jsApiList,
            'shopInfo' => $shopInfo,
            'pay_off' => ($shopInfo['end_time'] && $shopInfo['end_time'] - time() <= 0) ? 1 : 0
        ]);
        return View::fetch();
    }
    public function hexiao()
    {
        $pid = input('pid');
        $orderid = input('orderid');
        $gid = input('id');
        if(!$orderid || !$gid) {
            header('HTTP/1.1 404 Not Found');
            header("status: 404 Not Found");
            exit();
        }
        $userInfo = $this->getUserInfo();
        if(!$userInfo['is_hx']){
            header('HTTP/1.1 404 Not Found');
            header("status: 404 Not Found");
            exit();
        }
        $order = Db::name('app_kami_order')->where(['pid' => $pid, 'orderid' => $orderid, 'gid'=>$gid])->find();
        if (!$order || $order['status']!=1) $this->error('未知的订单信息');
        $shopInfo = Db::name('app_kami_shop')->where(['pid' => $pid, 'id' => $order['gid']])->find();
        $shopInfo['topimg'] = json_str_to_array($shopInfo['topimg']);
        //halt($shopInfo);exit();
        if($this->request->isPost()){
            Db::name('app_kami_order')->where(['id' => $order['id']])->update([
                'is_hexiao' => 1
            ]);
            $this->success('核销成功');
        }

        View::assign([
            'order' => $order,
            'shopInfo' => $shopInfo
        ]);
        return View::fetch();
    }
}