<?php


namespace app\app_kami\controller;


use app\ExcelExtend;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;
/**
 * @title 卡密管理
 */
class Kami  extends BaseController
{
    /**
     * @title 卡密列表
     */
    public function index(){
        $pid = input('pid');
        $id = input('id');
        $pageNum = 50;
        $keyword = input('keyword');
        $where = [
            ['a.pid', '=', $pid],
            ['a.gid', '=', $id]
        ];
        if($keyword){
            $where[] = ['a.code', 'like', '%'.$keyword.'%'];
        }
        $kami = Db::name('app_kami_kami')
            ->alias('a')->leftJoin('app_kami_user b','a.uid = b.id')
            ->where($where)->field('a.*,b.nickname,b.headimgurl')->order('a.id','DESC')->paginate($pageNum);
        //halt($kami);exit();
        View::assign([
           'kami'=>$kami,
           'page' => $kami->render(),
        ]);
        return View::fetch();

    }
    /**
     * @title 生成卡密
     */
    public function edit(){
        $pid = input('pid');
        $id = input('id');
        if($this->request->isPost()){
            $post = $this->request->post();
            $isPositiveInteger = is_numeric($post['length']) && is_int($post['length'] + 0) && ($post['length'] + 0) > 0;
            if(!$isPositiveInteger) $this->error('请输入正确的最小位数');
            if($post['length'] < 6) $this->error('位数不可小于6位');
            if(!$post['num']) $this->error('请输入要生成的数量');
            $data = [];
            $codes  = [];
            for($i=0;$i<$post['num'];$i++){
                $code = $post['qianzhui'].redom($post['length'], 3);
                if(in_array($code, $codes)){
                    $post['num'] ++;
                }else{
                    array_push($codes, $code);
                }
            }
            foreach($codes as $codeItem){
                $data[] = [
                    'pid' => $pid,
                    'code' => $codeItem,
                    'gid' => $id,
                    'create_time' => time()
                ];
            }
            $codes = array_unique($codes);
            Db::name('app_kami_kami')->insertAll($data);
            $this->success('操作成功');
        }
        return View::fetch();
    }
    /**
     * @title 删除卡密
     */
    public function del(){
        $ids = $this->request->post('ids');
        $query = Db::name('app_kami_kami')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 导入卡密
     */
    public function daoru(){
        $pid = input('pid');
        $id = input('id');

        if($this->request->isPost()){
            $kamis = input('kamis');
            $kamiTemp = [];
            foreach($kamis as $item){
                if($item) array_push($kamiTemp, $item);
            }
            if(!$kamiTemp) $this->error('请输入卡密');

            $postKamiCount = count($kamiTemp);
            $dbKami = Db::name('app_kami_kami')->where('code', 'in', $kamiTemp)->column('code');
            $kami = array_diff($kamiTemp, $dbKami);
            $kami = array_unique($kami);
            $kamiCount = count($kami);

            $data = [];
            foreach($kami as $ka){
                $data[] = [
                    'pid' => $pid,
                    'gid' => $id,
                    'code' => $ka,
                    'create_time' => time()
                ];
            }

            Db::name('app_kami_kami')->insertAll($data);

            $this->success('导入成功'.$kamiCount.'条，重复'.($postKamiCount - $kamiCount).'条');
        }

        return View::fetch();
    }

    /**
     * @title 导出导卡
     */
    public function export()
    {
        $pid = input('pid');
        $id = input('id');
        $type = input('type');
        $where = [
            ['k.pid', '=', $pid],
            ['k.gid', '=', $id]
        ];
        switch ($type){
            case 2:
                $where[] = ['k.pay_time', 'EXP', Db::raw('IS NOT NULL')];
                break;
            case 3:
                $where[] = ['k.pay_time', 'EXP', Db::raw('IS NULL')];
                break;
        }
        $kamis = Db::name('app_kami_kami')->alias('k')
            ->leftJoin('vit_app_kami_user u', 'k.uid=u.id')
            ->field('k.*, u.nickname')
            ->where($where)->order('k.id desc')->select();

        if($kamis->isEmpty()) $this->error('卡密数量为空');

        $data = $kamis->toArray();
        $exportData = [];
        foreach($data as $item){
            $exportData[] = [
                $item['code'],
                $item['nickname'] ?? '-',
                $item['pay_time'] ? date('Y-m-d H:i:s', $item['pay_time']) : '-'
            ];
        }

        $title = ['卡密', '使用人', '使用时间'];
        $filename = '卡密列表';

        $excel = new ExcelExtend($filename);
        $excel->setTitle($title);
        $excel->setData($exportData);
        exit();
    }
}