<?php


namespace app\app_kami\controller;


use app\ExcelExtend;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;

/**
 * @title 订单管理
 * @package app\app_kami\controller
 */
class Order extends BaseController
{
    /**
     * @title 订单列表
     */
    public function index()
    {
        $pid = input('pid');
        $id = input('id');
        $pageNum = 15;
        $orderid = input('orderid');
        $status = input('status');
        $where = [
            ['o.pid', '=', $pid],
            ['o.gid', '=', $id],
        ];
        if ($orderid) $where[] = ['o.orderid', 'like', '%' . $orderid . '%'];
        switch ($status) {
            case 2:
                $where[] = ['o.status', '=', 1];
                break;
            case 3:
                $where[] = ['o.status', 'EXP', Db::raw('IS NULL')];
                break;
        }
        $order = Db::name('app_kami_order')->alias('o')
            ->leftJoin('vit_app_kami_shop s', 's.id = o.gid')
            ->field('o.*, s.type shop_type')
            ->where($where)->order('o.id', 'DESC')->paginate($pageNum);
        View::assign([
            'order' => $order,
            'page' => $order->render(),
        ]);
        return View::fetch();
    }

    /**
     * @title 订单发货
     */
    public function fahuo()
    {
        $pid = input('pid');
        $gid = input('gid');
        $id = input('id');
        $order = Db::name('app_kami_order')->where(['pid' => $pid, 'gid' => $gid, 'id' => $id])->find();
        //判断是否post提交
        if (request()->isPost()) {
            $param = [
                'kd_name' => input('kd_name'),
                'kd_num' => input('kd_num')
            ];
            Db::name('app_kami_order')->where('id', $id)->update($param);
            $this->success("发货成功！", ('app_kami/order/index?pid=') . $pid . '&id=' . $gid);
        }
        View::assign([
            'order' => $order
        ]);
        return View::fetch();
    }

    /**
     * @title 订单核销
     */
    public function hexiao()
    {
        $pid = input('pid');
        $gid = input('id');
        $id = input('order_id');
        $order = Db::name('app_kami_order')->where(['pid' => $pid, 'gid' => $gid, 'id' => $id])->find();
        if(!$order) $this->error('未知的订单信息');
        if($order['is_hexiao']) $this->error('订单已核销，不可重复操作');

        Db::name('app_kami_order')->where(['id' => $order['id']])->update([
            'is_hexiao' => 1
        ]);
        $this->success('核销成功');
    }

    /**
     * @title 导出订单
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function export()
    {
        $pid = input('pid');
        $id = input('id');
        $where = [
            ['pid', '=', $pid],
            ['gid', '=', $id],
            ['status', '=', 1]
        ];
        $kamis = Db::name('app_kami_order')->where($where)->order('id desc')->select();

        if ($kamis->isEmpty()) $this->error('卡密数量为空');

        $data = $kamis->toArray();
        $exportData = [];
        foreach ($data as $item) {
            $exportData[] = [
                $item['orderid'],
                $item['fee'],
                $item['nickname'],
                $item['name'],
                $item['phone'],
                $item['address'],
                $item['kami'],
                $item['kd_name'],
                $item['kd_num'],
                $item['paytype'] == 1 ? '原价支付' : '卡密支付',
                $item['paytime'] ? date('Y-m-d H:i:s', $item['paytime']) : '-',
                $item['create_time'] ? date('Y-m-d H:i:s', $item['create_time']) : '-'
            ];
        }

        $title = ['订单号', '订单金额', '用户昵称', '收货人', '收货电话', '收货地址', '卡密', '快递公司', '快递单号', '支付类型', '支付时间', '订单生成时间'];
        $filename = '已支付订单列表';

        $excel = new ExcelExtend($filename);
        $excel->setTitle($title);
        $excel->setData($exportData);
        $excel->end();
    }
}