<?php

namespace app\app_kami\controller;

use think\facade\Db;
use think\facade\Log;

class Pay
{
    public function callback()
    {
        $pid = input('pid');
        $weixinConfig = Db::name('app_kami_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $weixinConfig['appsecret'],
            'appid' => $weixinConfig['appid'],
            'mch_id' => $weixinConfig['mchid'],
            'mch_key' => $weixinConfig['apikey']
        ];

        Db::startTrans();
        try {
            $wechat = new \WeChat\Pay($config);
            $result = $wechat->getNotify();
            Log::info('wepay', $result);
            Log::info(json_encode($result));

            $order = Db::name('app_kami_order')->where(['orderid' => $result['out_trade_no']])->lock(true)->find();
            if($order['status']==1){
                $wechat->toXml([
                    'return_code' => 'SUCCESS',
                    'return_msg' => 'OK'
                ]);
                exit();
            }
            Db::name('app_kami_order')->where('id', '=', $order['id'])->update([
                'status' => 1,
                'uniontid' => $result['transaction_id'],
                'paytime' => time()
            ]);

            Db::commit();
        } catch (\Exception $e) {
            Db::rollback();

            Log::error('支付出错了', [$e]);
            Log::error($e->getTraceAsString());
            Log::error($e->getMessage());
            Log::error('message', [$e->getMessage()]);
            throw $e;
        }

        $wechat->toXml([
            'return_code' => 'SUCCESS',
            'return_msg' => 'OK'
        ]);
        exit();
    }

    /**
     * 处理分佣
     */
    private function handleDirect($order, $userId, $pid)
    {
        $user = Db::name('cx_manghe_user')->where('id', $userId)->find();
        if(!$user || !$user['sid']) return;

        $sUser = Db::name('cx_manghe_user')->where('id', $user['sid'])->find();
        if(!$sUser || $sUser['is_fx']!=2) return;

        $setup = Db::name('cx_manghe_setup')->where('pid', $pid)->find();
        if(!$setup['yj_bl']) return;

        $yongjin = $order['fee'] * $setup['yj_bl'] / 100;
        $yongjin = round($yongjin, 2);
        if($yongjin <= 0.009) return;

        Db::name('cx_manghe_paylog')->where('id', '=', $order['id'])->update([
            'yongjin' => $yongjin
        ]);

        Db::name('cx_manghe_user')->where('id', $sUser['id'])->update([
            'balance' => $sUser['balance'] ? Db::raw('balance+'.$yongjin) : $yongjin
        ]);
    }
}