<?php

namespace app\app_kami\controller;

use think\facade\Db;
use think\facade\View;
use think\facade\Request;
use vitphp\admin\controller\BaseController;
/**
 * @title 活动列表
 */
class Shop extends BaseController
{
/**
 * @title 活动列表
 */
    public function index()
    {
        $pid = input('pid');
        $keyword = input('keyword');
        $where = [
            ['pid', '=', $pid]
        ];
        if($keyword){
            $where[] = ['title', 'like', '%'.$keyword.'%'];
        }
        $pageNum = 15;
        $shop = Db::name('app_kami_shop')->where($where)->order('id','desc')->paginate($pageNum);
        $shopData = $shop->items();
        foreach($shopData as &$shopItem){
            // 统计参数人数
            // 统计支付次数
            // 统计收金额
            $shopItem['user_count'] = Db::name('app_kami_user')->where('gid', '=', $shopItem['id'])->count();
            $shopItem['order_count'] = Db::name('app_kami_order')->where('gid', $shopItem['id'])->where('status', 1)->count();
            $shopItem['total_price'] = Db::name('app_kami_order')->where('gid', $shopItem['id'])->where('status', 1)->sum('fee');
            $shopItem['topimg'] = json_str_to_array($shopItem['topimg']);
        }
//halt($shopData);exit();
        $hdurl = Request::domain() . ToUrl('/app_kami');
        View::assign([
           'shop' => $shopData,
           'page' => $shop->render(),
           'hdurl' => !empty($hdurl) ? $hdurl : ''
        ]);
	    return View::fetch();
	}
	/**
     * @title 添加/编辑活动
     */
	public function edit(){
        $pid = input('pid');
        $id = input('id');
        $shop = Db::name('app_kami_shop')->where(['pid'=>$pid,'id'=>$id])->find();
        if($shop){
            $shop['end_time'] = $shop['end_time'] ? date('Y-m-d H:i:s', $shop['end_time']) : '2022-01-01 08:00:00';
            $shop['topimg'] = $shop['topimg'] ? json_decode($shop['topimg'], true) : [];
        }
        //判断是否post提交
        if(request()->isPost()){
            $copy = input('copy');
            $topimg = $this->getHdp();
            $param = [
                'title'=>input('title'),
                'topimg' => $topimg ? json_encode($topimg) : '',
                'describe'=>input('describe'),
                'fx_img'=>input('fx_img'),
                'fx_text'=>input('fx_text'),
                'old_price'=>input('old_price'),
                'new_price'=>input('new_price'),
                'sc_price'=>input('sc_price'),
                'yf_price'=>input('yf_price'),
                'yf_text'=>input('yf_text'),
                'details'=>input('details'),
                'kefu'=>input('kefu'),
                'phone'=>input('phone'),
                'store_address'=>input('store_address'),
                'location'=>input('location'),
                'music'=>input('music'),
                'copyright'=>input('copyright'),
                'end_time'=>strtotime(input('end_time')),
                'state'=>input('state'),
                'is_title'=>input('is_title'),
                'is_liucheng'=>input('is_liucheng'),
                'type'=>input('type'),
                'pid'=>$pid
            ];
            if ($id && !$copy){
                $res = Db::name('app_kami_shop')->where('id',$id)->update($param);
            }else{
                $res = Db::name("app_kami_shop")->save($param);
            }
            $this->success("保存成功！", ToUrl('app_kami/shop/index'));
        }
        View::assign([
            'shop'=>$shop
        ]);
        return View::fetch();
    }
    /**
     * @title 设置幻灯片
     */
    private function getHdp()
    {
        $hdp = [];
        $hdpImg = input('hdp_img');
        $hdpUrl = input('hdp_url');
        if(!$hdpImg) return $hdp;
        foreach($hdpImg as $k => $img){
            if(!$img) $this->error('请上传幻灯片图片');
            $hdp[] = [
                'img' => $img,
                'url' => $hdpUrl[$k] ?? ''
            ];
        }
        return $hdp;
    }
    /**
     * @title 删除活动
     */
    public function del(){
        $ids = $this->request->post('ids');
        $query = Db::name('app_kami_shop')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }

    /**
     * @title 设置活动开放或关闭
     */
    public function switch()
    {
        $pid = input('pid');
        $id = input('id');
        $state = input('state');
        if(!in_array($state, [1,2])) $this->error('未知的状态');

        Db::name('app_kami_shop')->where(['pid'=>$pid,'id'=>$id])->update(['state'=>$state]);
        $this->success('操作成功');
    }
    /**
     * @title 用户管理
     */
    public function user(){
        $pid = input('pid');
        $id = input('id');
        $nickname = input('nickname');
        $pageNum = 20;
        $where = [
            ['pid', '=', $pid],
            ['gid', '=', $id],
        ];
        if ($nickname) $where[] = ['nickname', 'like', '%' . $nickname . '%'];
        $user = Db::name('app_kami_user')->where($where)->paginate($pageNum);
        View::assign([
           'user'=>$user,
           'page' => $user->render(),
        ]);
        return View::fetch();
    }

    /**
     * @auth 0
     */
    public function setUserHx()
    {
        $pid = input('pid');
        $id = input('id');
        $userId = input('user_id');
        $isHx = input('is_hx');
        $isHx = $isHx==1 ? 1 : 0;
        Db::name('app_kami_user')->where(['pid'=>$pid,'gid'=>$id, 'id'=>$userId])->update([
            'is_hx'=>$isHx
        ]);
        $this->success('设置成功');
    }
    /**
     * @auth 0
     */
    public function openmap()
    {
        return View::fetch();
    }
}